viGui = {};

function viGui:setGetGuiLoadTables(self)
	viStoreItems = {};
	viGui.buttonGfxWidth1   = viGui:pxToNormal(1, 'x');
	viGui.buttonGfxHeight1  = viGui:pxToNormal(1, 'y');
	viGui.fsBaseMission = false;
	viGui.binding = {onOff=false, hiddenOnOff=false, mouseOnOff=false, mouseOnOffMoh=false, keySelectUp=false, keySelectDown=false, keySelectAction=false};
	viGui.fillHud = {
		on = true;		
		binding = false;
		zoomOutIn = 4;
		zoomOutInLevel = 0.5;
		zoomOutInMax = 8;
		zoomOutInMin = 2;
		newFillHud = false;		
		fruitNamesOn = false;
		fruitNameBold = false;
		fruitName = true;
		descName = false;
		textSize = 0.011;
		textMaxSize = 0.015;
		textMinSize = 0.007;
		textColor = viExtras.colors["yellow"];
		textSizeOutInLevel = 0.005;
		pos = 1;
		posMax = 4;
		clickArea = {};
	};
	viGui.fuelUsageHud = {
		on = true;
		binding = false;
		zoomOutIn = 4;
		zoomOutInLevel = 0.5;
		zoomOutInMax = 8;
		zoomOutInMin = 2;
		newFuelUsageHud	= false;	
		textSize = 0.011;
		textMaxSize = 0.015;
		textMinSize = 0.007;
		textColor = viExtras.colors["yellow"];
		textSizeOutInLevel = 0.005;
		clickArea = {};
	};
	viGui.speedHud = {
		on = true;
		binding = false;
		zoomOutIn = 4;
		zoomOutInLevel = 0.5;
		zoomOutInMax = 8;
		zoomOutInMin = 2;
		newSpeedHud	= false;	
		textSize = 0.011;
		textMaxSize = 0.015;
		textMinSize = 0.007;
		textColor = viExtras.colors["yellow"];
		textSizeOutInLevel = 0.005;
		clickArea = {};
	};
	if g_currentMission.vi == nil then g_currentMission.vi = {isOn=true,iconAnimals=false,isHidden=false,hiddenWarnings=true,setFrozen=true,isFrozen=false,isMouseCursor=false,foundMoh=false,frozenAndCursorOverMoh=false,isfruitNameOn=false,fruitNamePos=1,fruitNameType=1};end;
	viGui.defaultHud = {
		on = true;
		binding = false;		
		design = 1;
		hotSpot = false;
		designGroundType = 1; --0 no,1 transparent, 2 nicht transparent
		designGroundColor = {"white", "black", "gray", "activeRed", "darkGreen", "orange", "orangeRed", "darkBlue", "ls15Ground", "yellowGround", "deepPink", "mangenta", "purple", "chartreuse4", "khaki", "gold" };
		designGroundColorMarker = 1;
		designGroundLineColorMarker = 2;
		designGroundTransparent = 0.75;		
		distanceAttachedStretch = 1;
		distanceAttachedMaxStretch = 3;
		storeItems = true;
		storeItemsVehicle = true;
		storeItemsAttached = true;
		storeItemsColorMarker = 1;
		--storeItemsColor = viExtras.colors[viGui.defaultHud.designGrounColor[viGui.defaultHud.storeItemsColorMarker]];		
		--storeItemsColorName = "white"; 
		storeItemsVehicleName = false;
		storeItemsAttachedName = false;
		storeItemsTransparent = 1.00;
		helperName = false;
		bigbagAttached = true;
		controllerName = 1; --no
		vehicleName = false; --no
		vehicleType = false; --no
		attachedName = false; --no
		attachedType = false; --no
		attachedMax = 10;
		attachedView = 6;
		viewRealAttached = false;
		vehicleSettingsKeySelect = {on=true;pos=2;maxPos=3;node=nil;keyPos=0;vehicleCounter=0;markerType=3;maxMarkerType=3;color=13;timer=0}; --markerType 0-3
		warningColor0 = viExtras.colors["green"]; --green, >=90%
		warningColor1 = viExtras.colors["greenDisabled"]; --greenDisabled, < 90%, >=75%
		warningColor2 = viExtras.colors["yellow"]; --yellow, < 75%, >=50%
		warningColor3 = viExtras.colors["orange"]; --orange, < 50%, >=15%		
		warningColor4 = viExtras.colors["red"]; --red, < 15%
		-----
		seeAnimals = {on=true;chicken=true;sheep=true;cow=true;pig=true;dragDrop=false;posX=0.002;posY=0.995;width=0;heigt=0;defaultPos=true};
		clickAreaAnimals = {};
		-----
		seeGlobalWarningIcon = false;		
		seeGlobalWarningVehicleAutoOnHidden = false;
		seeGlobalWarningVehicle = false; --temp wird vom script gesetzt
		seeGlobalWarningVehicleAutoOff = false;
		seeGlobalWarningVehicleAutoOffTimer = 5;
		seeGlobalWarningVehicleAutoOffIsTimer = 0; --temp wird vom script gesetzt
		seeGlobalWarningVehicleOldHidden = g_currentMission.vi.isHidden; --temp wird vom script gesetzt
		-----
		sortBy = {vehicleName=false;typeName=true;typeDesc=false;engineOn=false;isGroup=false;isPlayer=false;isHired=false;isAttached=false;age=false;rentCar=false;isControlled=false;isFillLevel=false;isFuel=false,dirtAmount=false;vehiclePrice=false;vehicleSellPrice=false};
		sortByReverse = false;
		sortByOnly = true;
		sortByOnlyValue = {age=0;ageReverse=false;fillLevel=0;fillLevelReverse=false;fuelProzent=100;fuelProzentReverse=false;dirtAmount=0;dirtAmountReverse=false;rentCarTime=0;rentCarTimeReverse=false;vehiclePrice=0;vehiclePriceReverse=false;vehicleSellPrice=0;vehicleSellPriceReverse=false};		
		seeControlled = {player=true;playerTrain=true;playerCrane=true;playerHeli=true;foreignPlayer=true;foreignPlayerTrain=true;foreignPlayerCrane=true;foreignPlayerHeli=true;hired=true;hiredTrain=true;first=true;firstPos=0}; --0=first,1=last
		seeAttached = {
			setFilter = true;
			implement=false;
			attachableFrontloader=false;
			trailer=true;
			trailerLow=true;			
			semitrailerHook=true;
			hookLift=true;
			conveyor=true;
			semitrailer=true;
			manureBarrel=true;
			forageWagon=false;
			WagonFill=true;
			WagonTimber=false;
			cutter_animated=true;
			cutter=true;
			cutterHarvester=true;
			combine=true;
			combine_animated=true;
			stumpCutter=true;
			loadingTrailerDrivable=true;
			shovel=true;
			shovel_animated=true;
			dynamicMountAttacherTrailer=true;
			goldhoferFront=true;
			sowingMachineSprayer=true;
			sowingMachine=true;
			sowing=true;
			cultivator=true;
			unknown=true
		};
		seeVehicle = {		
			setFilter = true;
			tractor=true;
			tractor_articulatedAxis=true;
			tractor_reverseDriving=true;
			tractor_crawler=true;
			combine=true;
			combine_animated=true;
			combine_animated_crawler=true;
			telehandler=true;
			wheelLoader=true;
			cutter=true;
			cutterHarvester=true;
			skidSteer=true;
			selfPropelledSprayer=true;
			loadingTrailerDrivable=true;
			forwarder=true;
			car_dynamicMountAttacher=true;
			train=false;
			crane=false;
			heli=true;
			unknown=true
		};
		seeExtraIcon = {isDraw=true;selectedVehicle=true;attachedAllReady=false;attachedPlayerReady=true;attachedForeignPlayerReady=true;fuelLevel=true,fuelLevelProzent=10;fuelLevelTimer=-1;fillLevel=true,fillLevelProzent=70;fillLevelTimer=-1;light=true,rentCar=true;dirtAmount=true;dirtAmountProzent=90;vehicleCost=true;vehicleCostProzent=75};
		seeNoDrawWarning = {fillLevel=70;attachedFill=false;fuelLevel=10;attachedFuel=true;dirtAmount=-1;attachedDirt=true;problemHiredAndForeignPlayer=true;problemNoControlled=true};
		
		tableSort = {draw1=1;draw2=1;draw3=1}; --no
		tablePos ={draw1=1;draw2=1;draw3=1}; --no				
		seeGroup = {[1]=true;[2]=true;[3]=true;[4]=true;[5]=true;[6]=true;[7]=true;[8]=true;[9]=true;[10]=true;[0]=true;[11]=true,[12]=true}; --11=reverseGroup,12=see groupNumber	
		zoomOutIn = 3.5;
		zoomOutInLevel = 0.05;
		zoomOutInMax = 5;
		zoomOutInMin = 3;
		pos = 3;
		maxPos = 6;
		posX = 0.0015;
		posY = 0.994;			
		seeTrailerLine = 2; --1 max 1 under,2 max 2 under,3 max 3 under pro line
		seeText = {prozent=true;prozentTimer=-1;prozentPos=1;fillLevel=true;fillLevelTimer=-1;fillLevelPos=2;fruitName=false;fruitNameLenght=20;fruitNameTimer=-1;fruitNamePos=2;switch=false;switchTimer=1};
		fruitNameMaxLenght = 25;		
		textSizeBold = false; --no
		textSizeOverIcon = 0; --0.011; no
		textSize1Line = 0; --0.011; no
		textSize2Line = 0; --0.011; no
		textSize3Line = 0; --0.011; no
		textMaxSize = 0.015;
		textMinSize = 0.007;
		textSizeOutInLevel = 0.005;
		textColor = viExtras.colors["white"];
		colorName = {"white", "black", "closeRed", "darkGreen", "green", "orange", "orangeRed", "darkBlue", "ls15", "yellow", "deepPink", "mangenta", "purple", "chartreuse4", "khaki", "gold" };
		colorNameMarker = 1;
		mouseCursorJoinVehicleAutoOff = true;
		mouseCursorCloseSettingsAutoOff = true;
		clickArea = {};
	};
	viExtras:createTimers(self);
	viGui.defaultHud.textSizeOverIcon = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*2.9; --0.011; no
	viGui.defaultHud.textSize1Line = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*3.3; --0.011; no
	viGui.defaultHud.textSize2Line = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*3; --0.011; no
	viGui.defaultHud.textSize3Line = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*2.7; --0.011; no
	viGui.helpText = {
		on= true;
		vehicleInfo = true;
		size = 0.010;
		color = viExtras.colors["black"];
		groundColor = viExtras.colors["yellow"];
		posX=0;
		posY=0;
		txt="";
	};
	viGui.settingsOnViMenue = {		
		isLockDefaultHud = true;
		isTask = false;
		isTaskOpen = false;
		taskSelectKey = -2;
		maxSelectKey = -1;
		taskClickArea = {};
		dragDropPos = false;
		dragDropGround = {width=0,height=0};
		zoomOutIn = 4;
		zoomOutInLevel = 0.1;
		zoomOutInMax = 5;
		zoomOutInMin = 3;
		posX = 0.5;
		posY = 0.97;
		clickArea = {};
	};	
	viGui.settingsGuiMenue = {		
		on = false;
		zoomOutIn = 4;
		textSize = 0.010;
		textMaxSize = 0.015;
		textMinSize = 0.007;
		textSizeOutInLevel = 0.005;
		textColor = viExtras.colors["black"];
		groundColor = viExtras.colors["white"];
		markerColor = viExtras.colors["green"];
		clickArea = {};
	};
	viGui.iconSize = {
		m1x128   		= { 512, 2048 }; --Orginal Bildgröße x128
		m4x64   		= { 256, 2048 }; --x16
		m6x32   		= { 128, 256 }; --x8
		ls256   		= { 256, 256 }; --x8
		zoomToleranz	= { 0.005, 0.01 }; --zoom Toleranz
	};
	viGui.lsIcon = {
		test  = { 0, 2048, 0, 2048};		
	};
	viGui.icon = {		
		designGroundT   = { 0+0.1, 128*2-0.1, 8-0.1, 128+112+0.1};
		designLineT     = { 0+0.1, 128*2-0.1, 8-0.1, 128+112+0.1};
		designGround    = { 8+0.1, 128*2-0.1, 16-0.1, 128+112+0.1};
		designLine      = { 8+0.1, 128*2-0.1, 16-0.1, 128+112+0.1};
		designGroundNo  = { 0, 0, 0, 0};
		designLineNo    = { 0, 0, 0, 0};
		
		tractorLoader   = { 0+0.1, 128*1-0.1-96, 32-0.1, 0+0.1};
		sowing          = { 32+0.1, 128*1-0.1-96, 64-0.1, 0+0.1};
		loader          = { 64+0.1, 128*1-0.1-96, 96-0.1, 0+0.1};
		hubmast         = { 96+0.1, 128*1-0.1-96, 128-0.1, 0+0.1};
		
		tractor         = { 0+0.1, 128*1-0.1-64, 32-0.1, 0+32+0.1};
		trailerUnload   = { 32+0.1, 128*1-0.1-64, 64-0.1, 0+32+0.1};
		trailer         = { 64+0.1, 128*1-0.1-64, 96-0.1, 0+32+0.1};
		pickup          = { 96+0.1, 128*1-0.1-64, 128-0.1, 0+32+0.1};
		
		train           = { 0+0.1, 128*1-0.1-32, 32-0.1, 0+64+0.1};
		crane           = { 32+0.1, 128*1-0.1-32, 64-0.1, 0+64+0.1};
		truck           = { 64+0.1, 128*1-0.1-32, 96-0.1, 0+64+0.1};
		trailerFuel     = { 96+0.1, 128*1-0.1-32, 128-0.1, 0+64+0.1};
		
		test          	= { 0+0.1, 128*1-0.1, 32-0.1, 0+96+0.1};
		trailerLast     = { 32+0.1, 128*1-0.1, 64-0.1, 0+96+0.1};
		trailerUnknown  = { 64+0.1, 128*1-0.1, 96-0.1, 0+96+0.1};
		trainStore	    = { 96+0.1, 128*1-0.1, 128-0.1, 0+96+0.1};
		
		heliStore	    = { 0+0.1, 128*2-0.1-96, 32-0.1, 128+0.1};
		wagonTimberStore= { 32+0.1, 128*2-0.1-96, 64-0.1, 128+0.1};
		wagonStore	    = { 64+0.1, 128*2-0.1-96, 96-0.1, 128+0.1};
		craneStore	    = { 96+0.1, 128*2-0.1-96, 128-0.1, 128+0.1};		
		
		heli	    	= { 0+0.1, 128*2-0.1-96, 32-0.1, 128+80+0.1};
		bale	        = { 32+0.1, 128*2-0.1-64, 48-0.1, 128+48+0.1};
		fullPal 	    = { 48+0.1, 128*2-0.1-64, 64-0.1, 128+48+0.1};
		emptyPal 	    = { 48+0.1, 128*2-0.1-80, 64-0.1, 128+32+0.1};
		chicken	        = { 64+0.1, 128*2-0.1-80, 80-0.1, 128+32+0.1};
		pig 	        = { 80+0.1, 128*2-0.1-80, 96-0.1, 128+32+0.1};
		hidden	        = { 96+0.1, 128*2-0.1-80, 112-0.1, 128+32+0.1};
		warning	        = { 112+0.1, 128*2-0.1-80, 128-0.1, 128+32+0.1};
		cow	            = { 64+0.1, 128*2-0.1-64, 80-0.1, 128+48+0.1};
		sheep	        = { 80+0.1, 128*2-0.1-64, 96-0.1, 128+48+0.1};
		carWash	        = { 96+0.1, 128*2-0.1-64, 112-0.1, 128+48+0.1};
		money	        = { 112+0.1, 128*2-0.1-64, 128-0.1, 128+48+0.1};
		
		field	        = { 0+0.1, 128*2-0.1-48, 16-0.1, 128+64+0.1};
		park	        = { 16+0.1, 128*2-0.1-48, 32-0.1, 128+64+0.1};
		attention	    = { 32+0.1, 128*2-0.1-48, 48-0.1, 128+64+0.1};
		engine		    = { 48+0.1, 128*2-0.1-48, 64-0.1, 128+64+0.1};
		oel			    = { 64+0.1, 128*2-0.1-48, 80-0.1, 128+64+0.1};
		fuel	        = { 0+0.1, 128*2-0.1-32, 16-0.1, 128+80+0.1};
		repair1	        = { 16+0.1, 128*2-0.1-32, 32-0.1, 128+80+0.1};
		attached	    = { 32+0.1, 128*2-0.1-32, 48-0.1, 128+80+0.1};
		speed	        = { 48+0.1, 128*2-0.1-32, 64-0.1, 128+80+0.1};
		rentcar	        = { 64+0.1, 128*2-0.1-32, 80-0.1, 128+80+0.1};
		light	        = { 80+0.1, 128*2-0.1-32, 96-0.1, 128+80+0.1};
		newPosMouse     = { 96+0.1, 128*2-0.1-32, 112-0.1, 128+80+0.1};
		settings	    = { 112+0.1, 128*2-0.1-32, 128-0.1, 128+80+0.1};
				
		save			= { 0+0.1, 128*2-0.1-16, 16-0.1, 128+96+0.1};
		leftArrow		= { 16+0.1, 128*2-0.1-16, 32-0.1, 128+96+0.1};
		rightArrow		= { 32+0.1, 128*2-0.1-16, 48-0.1, 128+96+0.1};
		leftSwitchHalf	= { 48+0.1, 128*2-0.1-16, 64-0.1, 128+96+0.1};
		rightSwitchHalf	= { 64+0.1, 128*2-0.1-16, 80-0.1, 128+96+0.1};
		switchBig		= { 80+0.1, 128*2-0.1-16, 96-0.1, 128+96+0.1};
		select	        = { 112+0.1, 128*2-0.1-16, 128-0.1, 128+96+0.1};
		
		followMe        = { 32+0.1, 128*2-0.1, 48-0.1, 128+112+0.1};
		player	        = { 48+0.1, 128*2-0.1, 64-0.1, 128+112+0.1};
		repair2	        = { 64+0.1, 128*2-0.1, 80-0.1, 128+112+0.1};
		okay	        = { 80+0.1, 128*2-0.1, 96-0.1, 128+112+0.1};
		notOkay	        = { 96+0.1, 128*2-0.1, 112-0.1, 128+112+0.1};
		notReady	    = { 112+0.1, 128*2-0.1, 128-0.1, 128+112+0.1};
	};
end;

function viGui:setBackgroundColor(self, overlay, color)
	if overlay.overlayId then
		setOverlayColor(overlay.overlayId, unpack(color));		
	end;
end;

function viGui:setOverlay(self, overlay, posX, posY, width, height)	
	if overlay ~= nil and overlay.overlayId then
		if width then overlay.width = width;end;
		if height then overlay.height = height;end;
		if posX then overlay.x = posX;end;
		if posY then overlay.y = posY;end;
		--overlay:setPosition(posX, posY);end;
	end;
end;

function viGui:getOverlay(self, overlay)	
	if overlay ~= nil and overlay.overlayId then
		return overlay.x, overlay.y, overlay.width, overlay.height;			
	end;
	return nil;
end;

function viGui:resetOverlayDesignGroundAndLine(self)
	viGui:setOverlay(self, viGui["designGround"], 0, 0, 0, 0);
	viGui:setOverlay(self, viGui["designLine"], 0, 0, 0, 0);
	viGui:setOverlay(self, viGui["designGroundT"], 0, 0, 0, 0);
	viGui:setOverlay(self, viGui["designLineT"], 0, 0, 0, 0);
	viGui:setOverlay(self, viGui["designGroundNo"], 0, 0, 0, 0);
	viGui:setOverlay(self, viGui["designLineNo"], 0, 0, 0, 0);
end;

function viGui:setOverlayUVsPx(overlay, UVs, textureSizeX, textureSizeY)	
	if overlay.overlayId and overlay.currentUVs == nil or overlay.currentUVs ~= UVs then
		local leftX, bottomY, rightX, topY = unpack(UVs);
		local fromTop = false;
		if topY < bottomY then
			fromTop = true;
		end;
		local leftXNormal = leftX / textureSizeX;
		local rightXNormal = rightX / textureSizeX;
		local bottomYNormal = bottomY / textureSizeY;
		local topYNormal = topY / textureSizeY;
		if fromTop then
			bottomYNormal = 1 - bottomYNormal;
			topYNormal = 1 - topYNormal;
		end;
		setOverlayUVs(overlay.overlayId, leftXNormal,bottomYNormal, leftXNormal,topYNormal, rightXNormal,bottomYNormal, rightXNormal,topYNormal);
		overlay.currentUVs = UVs;
	end;
end;

local abs, ceil, floor, max, min, random, pow = math.abs, math.ceil, math.floor, math.max, math.min, math.random, math.pow;
function viGui:round(n, precision)
	if precision and precision > 0 then
		return floor((n * pow(10, precision)) + 0.5) / pow(10, precision);
	end;
	return floor(n + 0.5);
end;

local targetAspectRatio = 16/9;
local aspectRatioRatio = g_screenAspectRatio / targetAspectRatio;
local sizeRatio = 1;
if g_screenWidth >= 1920 then
	sizeRatio = 1920 / g_screenWidth;
elseif g_screenWidth < 1920 then
	sizeRatio = max((1920 / g_screenWidth) * 0.75, 1);
end;

function viGui:getFullPx(n, dimension)
	if dimension == 'x' then
		return viGui:round(n * g_screenWidth) / g_screenWidth;
	else
		return viGui:round(n * g_screenHeight) / g_screenHeight;
	end;
end;

function viGui:pxToNormal(px, dimension, fullPixel)
	local ret;
	if dimension == 'x' then
		ret = (px / 1920) * sizeRatio;
	else
		ret = (px / 1080) * sizeRatio * aspectRatioRatio;
	end;
	if fullPixel == nil or fullPixel then
		ret = viGui:getFullPx(ret, dimension);
	end;
	return ret;
end;

function viGui:setGetHotSpotMap(self, create, visible, posX, posZ, vehicleName)
	--ls17	
	if create then
		VehicleInspector.hotSpotMap = g_currentMission.ingameMap:createMapHotspot("hotSpotMap", "Vehicle", nil, getNormalizedUVs({8, 776, 240, 240}), {0.2705, 0.6514, 0.0802, 1}, 0, 0, nil, nil, true, true, false, 0, true, MapHotspot.CATEGORY_DEFAULT);
		VehicleInspector.hotSpotMap.showName = false;
		VehicleInspector.hotSpotMap.visible = false;
		VehicleInspector.hotSpotMap.overlayBg.visible = false;
		VehicleInspector.hotSpotMap.showNameDefault = false;
		VehicleInspector.hotSpotMap.overlays[1].visible = false;
		VehicleInspector.hotSpotMap.overlays[2].visible = false;
		VehicleInspector.hotSpotMap.overlays[3].visible = false;
		VehicleInspector.hotSpotMap.overlays[4].visible = false;
		VehicleInspector.hotSpotMap.overlays[5].visible = false;
		VehicleInspector.hotSpotMap.xMapPos = 0;
		VehicleInspector.hotSpotMap.zMapPos = 0;
		VehicleInspector.hotSpotMap.timer = 0;
	elseif visible ~= nil and visible then
		--MapHotspot:setCurrentShowName(VehicleInspector.hotSpotMap, "Test");		
		VehicleInspector.hotSpotMap.showNameDefault = true;
		VehicleInspector.hotSpotMap.fullViewName = Utils.getNoNil(vehicleName, "");
		VehicleInspector.hotSpotMap.showName = true;
		VehicleInspector.hotSpotMap.visible = true;		
		VehicleInspector.hotSpotMap.overlayBg.visible = true;
		VehicleInspector.hotSpotMap.overlays[1].visible = true;
		VehicleInspector.hotSpotMap.overlays[2].visible = true;
		VehicleInspector.hotSpotMap.overlays[3].visible = true;
		VehicleInspector.hotSpotMap.overlays[4].visible = true;
		VehicleInspector.hotSpotMap.overlays[5].visible = true;
		VehicleInspector.hotSpotMap.xMapPos = Utils.getNoNil(posX,0);
		VehicleInspector.hotSpotMap.zMapPos = Utils.getNoNil(posZ,0);		
	elseif visible ~= nil and not visible then
		VehicleInspector.hotSpotMap.showName = false;
		VehicleInspector.hotSpotMap.visible = false;
		VehicleInspector.hotSpotMap.showNameDefault = false;
		VehicleInspector.hotSpotMap.fullViewName = "";
		VehicleInspector.hotSpotMap.overlayBg.visible = false;
		VehicleInspector.hotSpotMap.overlays[1].visible = false;
		VehicleInspector.hotSpotMap.overlays[2].visible = false;
		VehicleInspector.hotSpotMap.overlays[3].visible = false;
		VehicleInspector.hotSpotMap.overlays[4].visible = false;
		VehicleInspector.hotSpotMap.overlays[5].visible = false;
		VehicleInspector.hotSpotMap.xMapPos = Utils.getNoNil(posX,0);
		VehicleInspector.hotSpotMap.zMapPos = Utils.getNoNil(posZ,0);
		VehicleInspector.hotSpotMap.timer = 0;
	end;	
end;


function viGui:loadViImages(self, deleteOld)
	
	--viGui["screenTest"] = Overlay:new('screenTest', "dataS2/menu/hud/mapHotspots_128.png", 0.3, 0.4, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*100, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*100);
	--viGui:setOverlayUVsPx(viGui["screenTest"], viGui.lsIcon["test"], viGui.iconSize.m1x128[1], viGui.iconSize.m1x128[2]);
	
	if deleteOld then viGui:deleteViImages(self, deleteOld);end;
	local iconFilePath = viGui:checkDesignFilePath(self);
	if iconFilePath == nil then return;end;
	--local lenght = utf8Strlen(asciiToUtf8("----Test----"));
	local lenght = getTextWidth(0.012, "----Test----")
	local height = getTextHeight(0.012, "----Test----")
	viGui["designGroundT"] = Overlay:new('designGroundT', iconFilePath, 0, 0, 0, 0);
	viGui:setOverlayUVsPx(viGui["designGroundT"], viGui.icon["designGroundT"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["designLineT"] = Overlay:new('designLineT', iconFilePath, 0, 0, viGui.buttonGfxWidth1*2, viGui.buttonGfxHeight1*2);
	viGui:setOverlayUVsPx(viGui["designLineT"], viGui.icon["designLineT"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["designGround"] = Overlay:new('designGround', iconFilePath, 0, 0, 0, 0);
	viGui:setOverlayUVsPx(viGui["designGround"], viGui.icon["designGround"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["designLine"] = Overlay:new('designLine', iconFilePath, 0, 0, viGui.buttonGfxWidth1*2, viGui.buttonGfxHeight1*2);
	viGui:setOverlayUVsPx(viGui["designLine"], viGui.icon["designLine"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	
	viGui:setOverlay(self, viGui["designLine"], 0.3, 0.9, lenght, false);
	viGui["designGroundNo"] = Overlay:new('designGroundNo', iconFilePath, 0, 0, 0, 0);
	viGui:setOverlayUVsPx(viGui["designGroundNo"], viGui.icon["designGroundNo"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["designLineNo"] = Overlay:new('designLineNo', iconFilePath, 0, 0, viGui.buttonGfxWidth1*2, viGui.buttonGfxHeight1*2);
	viGui:setOverlayUVsPx(viGui["designLineNo"], viGui.icon["designLineNo"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["designGroupLine"] = Overlay:new('designGroupLine', iconFilePath, 0, 0, viGui.buttonGfxWidth1*2, viGui.buttonGfxHeight1*2);
	viGui:setOverlayUVsPx(viGui["designGroupLine"], viGui.icon["designLine"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["designGroupLine"], viExtras.colors["ls15"]);
	viGui["designMarker"] = Overlay:new('designMarker', iconFilePath, 0, 0, viGui.buttonGfxWidth1*2, viGui.buttonGfxHeight1*2);
	viGui:setOverlayUVsPx(viGui["designMarker"], viGui.icon["designLine"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	
	viGui["menueGuiGround"] = Overlay:new('menueGuiGround', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*6, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5);
	viGui:setOverlayUVsPx(viGui["menueGuiGround"], viGui.icon["designGroundT"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);	
	viGui:setBackgroundColor(self, viGui["menueGuiGround"], viGui.settingsGuiMenue.groundColor);
	viGui["dragDropGround"] = Overlay:new('dragDropGround', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*6, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5);
	viGui:setOverlayUVsPx(viGui["dragDropGround"], viGui.icon["designGroundT"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["dragDropGround"], viExtras.colors["green"]);
	
	viGui["helpGround"] = Overlay:new('helpGround', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*6, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5);
	viGui:setOverlayUVsPx(viGui["helpGround"], viGui.icon["designGround"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["helpGround"], viGui.helpText.groundColor);
	--viGui["designGround"] = Overlay:new('designGround', "dataS2/menu/blank.png", 0.3, 0.9, lenght, height);
	--viGui["designGround"] = Overlay:new('designGround', "dataS2/menu/blank.png", 0.3, 0.9, viGui.buttonGfxWidth1*12, viGui.buttonGfxHeight1*10);
	--viGui:setOverlayUVsPx(viGui["designGroundT"], "dataS2/menu/blank.png", viGui.iconSize.m4x64[1], viGui.iconSize.m4x64[2]);
	
	viGui["speed"] = Overlay:new('speed', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["speed"], viGui.icon["speed"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["speed"], viExtras.colors["greenDisabled"]);
	viGui["field"] = Overlay:new('field', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["field"], viGui.icon["field"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["field"], viExtras.colors["whiteDisabled"]);
	viGui["fuel"] = Overlay:new('fuel', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*4.5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*3.5);
	viGui:setOverlayUVsPx(viGui["fuel"], viGui.icon["fuel"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["fuel"], viExtras.colors["red"]);
	viGui["park"] = Overlay:new('park', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["park"], viGui.icon["park"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["park"], viExtras.colors["green"]);
	viGui["attention"] = Overlay:new('attention', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*4.5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*3.5);
	viGui:setOverlayUVsPx(viGui["attention"], viGui.icon["attention"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["attention"], viExtras.colors["yellow"]);
	viGui["repair1"] = Overlay:new('repair1', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["repair1"], viGui.icon["repair1"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["repair1"], viExtras.colors["yellow"]);
	viGui["repair2"] = Overlay:new('repair2', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["repair2"], viGui.icon["repair2"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["repair2"], viExtras.colors["orange"]);
	viGui["engine"] = Overlay:new('engine', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["engine"], viGui.icon["engine"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["engine"], viExtras.colors["green"]);
	viGui["rentcar"] = Overlay:new('rentcar', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*4.5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*3.5);
	viGui:setOverlayUVsPx(viGui["rentcar"], viGui.icon["rentcar"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["rentcar"], viExtras.colors["green"]);
	viGui["light"] = Overlay:new('light', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*4.5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*3.5);
	viGui:setOverlayUVsPx(viGui["light"], viGui.icon["light"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["light"], viGui.defaultHud.warningColor2);
	viGui["oel"] = Overlay:new('oel', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["oel"], viGui.icon["oel"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["oel"], viExtras.colors["yellow"]);
	viGui["attached"] = Overlay:new('attached', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["attached"], viGui.icon["attached"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);	
	viGui:setBackgroundColor(self, viGui["oel"], viExtras.colors["darkGreen"]);
	viGui["select"] = Overlay:new('select', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["select"], viGui.icon["select"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["select"], viExtras.colors["gold"]);
	viGui["player"] = Overlay:new('player', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["player"], viGui.icon["player"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["followMe"] = Overlay:new('followMe', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["followMe"], viGui.icon["followMe"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["money"] = Overlay:new('money', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*4.5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*3.5);
	viGui:setOverlayUVsPx(viGui["money"], viGui.icon["money"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["carWash"] = Overlay:new('carWash', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*4.5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*3.5);
	viGui:setOverlayUVsPx(viGui["carWash"], viGui.icon["carWash"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["warning"] = Overlay:new('warning', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*6, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5);
	viGui:setOverlayUVsPx(viGui["warning"], viGui.icon["warning"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["hidden"] = Overlay:new('hidden', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*6, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5);
	viGui:setOverlayUVsPx(viGui["hidden"], viGui.icon["hidden"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["okay"] = Overlay:new('okay', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["okay"], viGui.icon["okay"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["notOkay"] = Overlay:new('notOkay', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["notOkay"], viGui.icon["notOkay"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["notReady"] = Overlay:new('notReady', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["notReady"], viGui.icon["notReady"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	
	viGui["save"] = Overlay:new('save', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["save"], viGui.icon["save"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["save"], viExtras.colors["green"]);
	viGui["leftArrow"] = Overlay:new('leftArrow', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["leftArrow"], viGui.icon["leftArrow"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["leftArrow"], viExtras.colors["yellow"]);
	viGui["rightArrow"] = Overlay:new('rightArrow', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["rightArrow"], viGui.icon["rightArrow"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui:setBackgroundColor(self, viGui["rightArrow"], viExtras.colors["yellow"]);
	viGui["leftSwitchHalf"] = Overlay:new('leftSwitchHalf', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["leftSwitchHalf"], viGui.icon["leftSwitchHalf"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["rightSwitchHalf"] = Overlay:new('rightSwitchHalf', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["rightSwitchHalf"], viGui.icon["rightSwitchHalf"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["switchBig"] = Overlay:new('switchBig', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4);
	viGui:setOverlayUVsPx(viGui["switchBig"], viGui.icon["switchBig"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["settings"] = Overlay:new('settings', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*6, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5);
	viGui:setOverlayUVsPx(viGui["settings"], viGui.icon["settings"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["newPosMouse"] = Overlay:new('newPosMouse', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*6, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5);
	viGui:setOverlayUVsPx(viGui["newPosMouse"], viGui.icon["newPosMouse"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["chicken"] = Overlay:new('chicken', iconFilePath, 0, 0, viGui.buttonGfxWidth1*3.5*6, viGui.buttonGfxHeight1*3.5*5);
	viGui:setOverlayUVsPx(viGui["chicken"], viGui.icon["chicken"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["pig"] = Overlay:new('pig', iconFilePath, 0, 0, viGui.buttonGfxWidth1*3.5*6, viGui.buttonGfxHeight1*3.5*5);
	viGui:setOverlayUVsPx(viGui["pig"], viGui.icon["pig"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["cow"] = Overlay:new('cow', iconFilePath, 0, 0, viGui.buttonGfxWidth1*3.5*6, viGui.buttonGfxHeight1*3.5*5);
	viGui:setOverlayUVsPx(viGui["cow"], viGui.icon["cow"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["sheep"] = Overlay:new('sheep', iconFilePath, 0, 0, viGui.buttonGfxWidth1*3.5*6, viGui.buttonGfxHeight1*3.5*5);
	viGui:setOverlayUVsPx(viGui["sheep"], viGui.icon["sheep"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
end;

function viGui:deleteViImages(self)
	viGui:deleteOldOverlay(viGui["designGroundT"]);
	viGui:deleteOldOverlay(viGui["designLineT"]);
	viGui:deleteOldOverlay(viGui["designGround"]);
	viGui:deleteOldOverlay(viGui["designLine"]);
	viGui:deleteOldOverlay(viGui["designGroundNo"]);
	viGui:deleteOldOverlay(viGui["designLineNo"]);
	viGui:deleteOldOverlay(viGui["designMarker"]);
	viGui:deleteOldOverlay(viGui["designGroupLine"]);
	viGui:deleteOldOverlay(viGui["speed"]);	
	viGui:deleteOldOverlay(viGui["field"]);
	viGui:deleteOldOverlay(viGui["fuel"]);
	viGui:deleteOldOverlay(viGui["attention"]);
	viGui:deleteOldOverlay(viGui["repair1"]);
	viGui:deleteOldOverlay(viGui["repair2"]);
	viGui:deleteOldOverlay(viGui["engine"]);
	viGui:deleteOldOverlay(viGui["rentcar"]);
	viGui:deleteOldOverlay(viGui["light"]);
	viGui:deleteOldOverlay(viGui["oel"]);
	viGui:deleteOldOverlay(viGui["attached"]);
	viGui:deleteOldOverlay(viGui["select"]);
	viGui:deleteOldOverlay(viGui["player"]);
	viGui:deleteOldOverlay(viGui["followMe"]);
	viGui:deleteOldOverlay(viGui["money"]);
	viGui:deleteOldOverlay(viGui["carWash"]);
	viGui:deleteOldOverlay(viGui["warning"]);
	viGui:deleteOldOverlay(viGui["hidden"]);
	viGui:deleteOldOverlay(viGui["okay"]);
	viGui:deleteOldOverlay(viGui["notOkay"]);
	viGui:deleteOldOverlay(viGui["notReady"]);
	viGui:deleteOldOverlay(viGui["save"]);
	viGui:deleteOldOverlay(viGui["leftArrow"]);
	viGui:deleteOldOverlay(viGui["rightArrow"]);
	viGui:deleteOldOverlay(viGui["leftSwitchHalf"]);
	viGui:deleteOldOverlay(viGui["rightSwitchHalf"]);
	viGui:deleteOldOverlay(viGui["switchBig"]);
	viGui:deleteOldOverlay(viGui["settings"]);
	viGui:deleteOldOverlay(viGui["menueGuiGround"]);
	viGui:deleteOldOverlay(viGui["helpGround"]);
	viGui:deleteOldOverlay(viGui["dragDropGround"]);
	viGui:deleteOldOverlay(viGui["newPosMouse"]);	
	viGui:deleteOldOverlay(viGui["chicken"]);
	viGui:deleteOldOverlay(viGui["pig"]);
	viGui:deleteOldOverlay(viGui["cow"]);
	viGui:deleteOldOverlay(viGui["sheep"]);
end;

function viGui:loadVehicleImages(self, deleteOld)
	if deleteOld then viGui:deleteVehicleImages(self, deleteOld);end;
	local iconFilePath = viGui:checkDesignFilePath(self);
	if iconFilePath == nil then return;end;
	
	viGui["tractorLoader"] = Overlay:new('tractorLoader', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["tractorLoader"], viGui.icon["tractorLoader"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["sowing"] = Overlay:new('sowing', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["sowing"], viGui.icon["sowing"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["loader"] = Overlay:new('loader', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["loader"], viGui.icon["loader"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["hubmast"] = Overlay:new('hubmast', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["hubmast"], viGui.icon["hubmast"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["tractor"] = Overlay:new('tractor', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["tractor"], viGui.icon["tractor"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["trailerUnload"] = Overlay:new('trailerUnload', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["trailerUnload"], viGui.icon["trailerUnload"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["trailer"] = Overlay:new('trailer', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["trailer"], viGui.icon["trailer"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["pickup"] = Overlay:new('pickup', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["pickup"], viGui.icon["pickup"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["train"] = Overlay:new('train', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["train"], viGui.icon["train"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["trainStore"] = Overlay:new('trainStore', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["trainStore"], viGui.icon["trainStore"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["wagonStore"] = Overlay:new('wagonStore', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["wagonStore"], viGui.icon["wagonStore"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["wagonTimberStore"] = Overlay:new('wagonTimberStore', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["wagonTimberStore"], viGui.icon["wagonTimberStore"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["bale"] = Overlay:new('bale', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*8, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*7);
	viGui:setOverlayUVsPx(viGui["bale"], viGui.icon["bale"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["fullPal"] = Overlay:new('fullPal', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*8, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*7);
	viGui:setOverlayUVsPx(viGui["fullPal"], viGui.icon["fullPal"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["emptyPal"] = Overlay:new('emptyPal', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*8, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*7);
	viGui:setOverlayUVsPx(viGui["emptyPal"], viGui.icon["emptyPal"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["crane"] = Overlay:new('crane', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["crane"], viGui.icon["crane"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["craneStore"] = Overlay:new('craneStore', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["craneStore"], viGui.icon["craneStore"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["truck"] = Overlay:new('truck', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["truck"], viGui.icon["truck"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["trailerFuel"] = Overlay:new('trailerFuel', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["trailerFuel"], viGui.icon["trailerFuel"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["test"] = Overlay:new('test', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["test"], viGui.icon["test"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["trailerLast"] = Overlay:new('trailerLast', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["trailerLast"], viGui.icon["trailerLast"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["trailerUnknown"] = Overlay:new('trailerUnknown', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["trailerUnknown"], viGui.icon["trailerUnknown"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["frontLoaderArm"] = Overlay:new('frontLoaderArm', "dataS2/menu/hud/configurations/config_engine.png", 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	--viGui:setOverlayUVsPx(viGui["frontLoaderArm"], "dataS2/menu/hud/configurations/config_loader.png", viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["heliStore"] = Overlay:new('heliStore', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["heliStore"], viGui.icon["heliStore"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	viGui["heli"] = Overlay:new('heli', iconFilePath, 0, 0, viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*9, viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8);
	viGui:setOverlayUVsPx(viGui["heli"], viGui.icon["heli"], viGui.iconSize.m6x32[1], viGui.iconSize.m6x32[2]);
	lenght = getTextWidth(0.012, "----Test----")
	local height = getTextHeight(0.012, "----Test----")
	--viGui["train"] = Overlay:new('train', "dataS/menu/mapHotspotTrain_1024.png", 0.3-height, 0.9, height, height);
	local desc = FillUtil.fillTypeIndexToDesc[1];
	local file = desc.hudOverlayFilenameSmall;
	viGui["fruitIcon"] = Overlay:new('fruitIcon', file, 0.3-height, 0.9, height, height);
end;

function viGui:deleteVehicleImages(self)	
	viGui:deleteOldOverlay(viGui["fruitIcon"]);
	viGui:deleteOldOverlay(viGui["tractor"]);
	viGui:deleteOldOverlay(viGui["tractorLoader"]);
	viGui:deleteOldOverlay(viGui["sowing"]);
	viGui:deleteOldOverlay(viGui["loader"]);
	viGui:deleteOldOverlay(viGui["hubmast"]);
	viGui:deleteOldOverlay(viGui["trailerUnload"]);
	viGui:deleteOldOverlay(viGui["trailer"]);
	viGui:deleteOldOverlay(viGui["pickup"]);
	viGui:deleteOldOverlay(viGui["train"]);
	viGui:deleteOldOverlay(viGui["bale"]);
	viGui:deleteOldOverlay(viGui["fullPal"]);
	viGui:deleteOldOverlay(viGui["emptyPal"]);
	--viGui:deleteOldOverlay(viGui["trainStore"]);
	--viGui:deleteOldOverlay(viGui["wagonStore"]);
	viGui:deleteOldOverlay(viGui["crane"]);
	--viGui:deleteOldOverlay(viGui["craneStore"]);
	--viGui:deleteOldOverlay(viGui["heliStore"]);
	viGui:deleteOldOverlay(viGui["heli"]);
	viGui:deleteOldOverlay(viGui["trailerFuel"]);
	viGui:deleteOldOverlay(viGui["truck"]);
	viGui:deleteOldOverlay(viGui["test"]);
	viGui:deleteOldOverlay(viGui["trailerLast"]);
	viGui:deleteOldOverlay(viGui["trailerUnknown"]);
	viGui:deleteOldOverlay(viGui["frontLoaderArm"]);
end;

function viGui:deleteOldOverlay(overlay)
	if overlay ~= nil and overlay and overlay.overlayId ~= nil and overlay.overlayId then
		overlay:delete();
		overlay = nil;		
	end;
end;

function viGui:deleteStoreItems(self)
	if viStoreItems ~= nil then		
		for key, value in pairs(viStoreItems) do			
			if key ~= nil then
				viGui:deleteOldOverlay(viStoreItems[key]);				
			end;
		end;
	end;
end;

function viGui:loadAllOverlays(self)	
	viGui:loadViImages(self, false);
	viGui:loadVehicleImages(self, false);
end;

function viGui:deleteAllOverlays(self)	
	viGui:deleteViImages(self);
	viGui:deleteVehicleImages(self);
	viGui:deleteStoreItems(self);
end;

function viGui:checkDesignFilePath(self)	
	local iconFilePath = Utils.getFilename("viDesign.dds", VehicleInspector.modDir );			
	if not fileExists(iconFilePath) then		
		iconFilePath = nil;				
	end;
	return iconFilePath;
end;